local mapMod = foundation.createMod();

mapMod:registerAssetId("map1_high-res-heightmap.png", "MAP1_HEIGHTMAP")
mapMod:registerAssetId("map1_materialmask.png", "MAP1_MATERIALMASK")
mapMod:registerAssetId("map1_oakdensity.png", "MAP1_OAK_DENSITY")
mapMod:registerAssetId("map1_sycamoredensity.png", "MAP1_SYCAMORE_DENSITY")
mapMod:registerAssetId("map1_poplardensity.png", "MAP1_POPLAR_DENSITY")
mapMod:registerAssetId("map1_coniferousdensity.png", "MAP1_CONIFEROUS_DENSITY")
mapMod:registerAssetId("map1_berrydensity.png", "MAP1_BERRY_DENSITY")
mapMod:registerAssetId("map1_stonedensity.png", "MAP1_STONE_DENSITY")
mapMod:registerAssetId("map1_fishdensity.png", "MAP1_FISH_DENSITY")

-- Register Custom Map
mapMod:register({
	DataType = "CUSTOM_MAP",
	Id = "SYCAMORE_VALLEY",
	HeightMap = "MAP1_HEIGHTMAP",
	MaterialMask = "MAP1_MATERIALMASK",
	MinHeight = -1,
	MaxHeight = 200,
	VillagePathList = {
		{
			Entrance = { 1015, 0, 298 },
			Exit = { 753, 0, 8 },
		},
		{
			Entrance = { 9, 0, 116 },
			Exit = { 663, 0, 11 },
		},
		{
			Entrance = { 1010, 0, 416 },
			Exit = { 17, 0, 752 },
		}
	},
	SpawnList = {
		{
			-- creating Mineral Deposit 1
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 805 , 3 , 174 },
			Orientation = { 0.0, 270.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 2
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 938 , 63 , 151 },
			Orientation = { 0.0, 320.0 , 0.0},
		},
		{
			-- creating Mineral Deposit 3
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 735 , 2 , 407 },
			Orientation = { 0.0, 330.0 , 0.0},
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 631 , 3 , 553 },
			Orientation = { 0.0, 95.0 , 0.0},
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 886 , 44 , 54 },
			Orientation = { 0.0, 270.0 , 0.0},
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 472 , 27 , 179 },
			Orientation = { 0.0, 300.0 , 0.0},
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 372 , 37 , 77 },
			Orientation = { 0.0, 340.0 , 0.0},
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 201 , 31 , 80 },
			Orientation = { 0.0, 341.0 , 0.0},
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 384 , 1 , 351 },
			Orientation = { 0.0, 330.0 , 0.0},
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 205 , 4 , 440 },
			Orientation = { 0.0, 240.0 , 0.0},
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 287 , 34 , 611 },
			Orientation = { 0.0, 110.0 , 0.0},
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 552 , 6 , 353 },
			Orientation = { 0.0, 10.0 , 0.0},
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 931 , 20 , 712 },
			Orientation = { 0.0, 300.0 , 0.0},
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 141 , 0 , 244 },
			Orientation = { 0.0, 0.0 , 0.0},
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 447 , 26 , 697 },
			Orientation = { 0.0, 0.0 , 0.0},
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_2",
			Position = { 825 , 34 , 903 },
			Orientation = { 0.0, 180.0 , 0.0},
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_3",
			Position = { 211 , 64 , 900 },
			Orientation = { 0.0, 180.0 , 0.0},
		},
		{
			Prefab = "PREFAB_MINERAL_SOURCE_1",
			Position = { 407 , 74 , 950 },
			Orientation = { 0.0, 0.0 , 0.0},
		},
	},
DensitySpawnList = {
		{
			DensityMap = "MAP1_OAK_DENSITY",
			Density = 0.70,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_OAK" },
					RandomWeight = 0.25,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 1.00,
						Max = 1.45
					},
					ColorRange = {
						Min = { 0.8, 0.9, 1.0, 1.0 },
						Max = { 1.0, 1.0, 1.0, 1.0 }
					}
				},
			}
		},
		{
			DensityMap = "MAP1_SYCAMORE_DENSITY",
			Density = 0.70,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_SYCAMORE" },
					RandomWeight = 0.5,
					OffsetSizeRange = {
						Min = 1.00,
						Max = 1.25
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 1.00,
						Max = 1.35
					},
					ColorRange = {
						Min = { 0.8, 0.9, 1.0, 1.0 },
						Max = { 1.0, 1.0, 1.0, 1.0 }
					}
				},
			}
		},
		{
			DensityMap = "MAP1_POPLAR_DENSITY",
			Density = 0.65,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_POPLAR" },
					RandomWeight = 0.25,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.25
					},
					ColorRange = {
						Min = { 0.8, 0.9, 1.0, 1.0 },
						Max = { 1.0, 1.0, 1.0, 1.0 }
					}
				},
			}
		},
		{
			-- Create the berries
			DensityMap = "MAP1_BERRY_DENSITY",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_BERRIES" },
					RandomWeight = 1,
					OffsetSizeRange = {
						Min = 1,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 1,
						Max = 1
					},
					ColorRange = {
						Min = { 1, 1, 1, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create the stones
			DensityMap = "MAP1_STONE_DENSITY",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_ROCK" },
					RandomWeight = 1,
					OffsetSizeRange = {
						Min = 1,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 1,
						Max = 1
					},
					ColorRange = {
						Min = { 1, 1, 1, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create the fish
			DensityMap = "MAP1_FISH_DENSITY",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_FISH" },
					RandomWeight = 1,
					OffsetSizeRange = {
						Min = 1,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 1,
						Max = 1
					},
					ColorRange = {
						Min = { 1, 1, 1, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
	}
})